/******************************************************************

         Copyright 1993, 1994 by Hewlett-Packard Company

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose without fee is hereby granted,
provided that the above copyright notice appear in all copies and
that both that copyright notice and this permission notice appear
in supporting documentation, and that the name of Hewlett-Packard not
be used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.
Hewlett-Packard Company makes no representations about the suitability
of this software for any purpose.
It is provided "as is" without express or implied warranty.

HEWLETT-PACKARD COMPANY DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
IN NO EVENT SHALL HEWLETT-PACKARD COMPANY BE LIABLE FOR ANY SPECIAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

Author:
    Hidetoshi Tajima	Hewlett-Packard Company.
			(tajima@kobe.hp.com)
******************************************************************/
#ifndef _Xi18nTrX_h
#define _Xi18nTrX_h

#define _XIM_PROTOCOL           "_XIM_PROTOCOL"
#define _XIM_XCONNECT           "_XIM_XCONNECT"

typedef struct _XClient {
    CARD16	connection_id;
    Window	client_win;	/* client window */
    Window	accept_win;	/* accept window */
    CARD8	byte_order;
				/* 'B' for Big-Endian */
				/* 'l' for little-Endian */
				/* '?': initial value */
    int		sync;		/* True if in sync */
    struct _XClient	*next;
} XClient;

typedef struct {
    Atom	 xim_request;
    Atom	 connect_request;
    XClient	*clients;
    XClient	*freeclients;
} XSpecRec;

extern Bool _xi18n_XBegin(
#if NeedFunctionPrototypes
	XIMS
#endif
);

extern Bool _xi18n_XEnd(
#if NeedFunctionPrototypes
	XIMS
#endif
);

extern Bool _xi18n_XSend(
#if NeedFunctionPrototypes
	XIMS,
	CARD16 ,
	unsigned char* ,
	long
#endif
);

extern Bool _xi18n_XWait(
#if NeedFunctionPrototypes
	XIMS,
	CARD16,
	CARD8,
	CARD8
#endif
);

#endif /* Xi18nTrX_h */
